#include <syslog.h>
#include <stdarg.h>
#include <stdio.h>

#include "log.h"

void log(context_t *c, int level, char *format, ...) {
    va_list ap;
    va_start(ap, format);

//    vfprintf(stderr, format, ap);
//    fprintf(stderr, "\n");
    
    if (c->opt_debug || (level != LOG_DEBUG && level != LOG_WARNING) || (level == LOG_WARNING && !c->opt_no_warn)) {
        static char ln[256];
        char *p;
        
        if (c->service)
            snprintf(p = ln, sizeof(ln), "%s(pam_dotfile)", c->service);
        else
            p = "pam_dotfile";
        
        openlog(p, LOG_PID, LOG_AUTHPRIV);
        vsyslog(level, format, ap);
        closelog();
    }

    va_end(ap);
}
