#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>

#include "md5.h"
#include "md5util.h"

static void _random(char *r, int l) {
    FILE *f;
    int b = 0;

    if ((f = fopen("/dev/urandom", "r"))) {
        if (fread(r, l, 1, f) == 1)
            b = 1;
        fclose(f);
    }

    if (!b) {
        int i;
        fprintf(stderr, "WARNING: Could not read /dev/urandom, generating pseudo randomness.\n");

        for (i = 0; i < l; i++)
            r[i] = (unsigned char) rand() & 0xFF;
    }
}

static void _md5_gen(const char *password) {
    static unsigned char salt[16];
    static char saltc[33];
    static unsigned char  digest[16];
    static char digestc[33];
    md5_state_t t;
    
    _random(salt, 16);
    
    fhex(salt, 16, saltc);
    saltc[32] = 0;

    md5_init(&t);
    md5_append(&t, saltc, 32);
    md5_append(&t, password, strlen(password));
    md5_finish(&t, digest);

    fhex_md5(digest, digestc);
    digestc[32] = 0;
    
    fprintf(stdout, "%s%s\n", saltc, digestc);
}

int main(int argc, char*argv[]) {
    srand(time(NULL)*getpid());
        
    for(;;) {
        int n;
        static char ln[256];
        
        if (!fgets(ln, sizeof(ln), stdin))
            break;

        if (ln[0] == 0 || ln[0] == '\n' || ln[0] == '#') {
            fputs(ln, stdout);
            continue;
        }

        if (ln[(n = strlen(ln))-1] == '\n')
            ln[n-1] = 0;

        _md5_gen(ln);
    }

    return 0;
}
